 processor 6502
 include "vcs.h"
 include "macro.h"
 include "DPCplus.h"
 include "DPCplusbB.h"
 include "2600basic_variable_redefs.h"
 ORG $400
 RORG $0
 incbin DPCplus.arm
     ORG $1000
     RORG $1000
 incbin custom/bin/custom2.bin
; assume custom2.bin > 128 bytes
; repeat $80
; .byte 0
; repend
; feel free to modify the score graphics - just keep each digit 8 high
; and keep the conditional compilation stuff intact
 ifconst ROM2k
   ORG $F7AC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2F94-bscode_length
       RORG $FF94-bscode_length
     endif
     if bankswitch == 16
       ORG $4F94-bscode_length
       RORG $FF94-bscode_length
     endif
     if bankswitch == 32
       ORG $8F94-bscode_length
       RORG $FF94-bscode_length
     endif
   else
     ORG $FF9C
   endif
 endif

; font equates
.21stcentury = 1
alarmclock = 2     
handwritten = 3    
interrupted = 4    
retroputer = 5    
whimsey = 6

scoretable

 ifconst font
  if font == .21stcentury
    include "score_graphics.asm.21stcentury"
  endif
  if font == alarmclock
    include "score_graphics.asm.alarmclock"
  endif
  if font == handwritten
    include "score_graphics.asm.handwritten"
  endif
  if font == interrupted
    include "score_graphics.asm.interrupted"
  endif
  if font == retroputer
    include "score_graphics.asm.retroputer"
  endif
  if font == whimsey
    include "score_graphics.asm.whimsey"
  endif
 else ; default font

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %01111110
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00111000
       .byte %00011000
       .byte %00001000

       .byte %01111110
       .byte %01100000
       .byte %01100000
       .byte %00111100
       .byte %00000110
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00011100
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00001100
       .byte %00001100
       .byte %01111110
       .byte %01001100
       .byte %01001100
       .byte %00101100
       .byte %00011100
       .byte %00001100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00111100
       .byte %01100000
       .byte %01100000
       .byte %01111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01111100
       .byte %01100000
       .byte %01100010
       .byte %00111100

       .byte %00110000
       .byte %00110000
       .byte %00110000
       .byte %00011000
       .byte %00001100
       .byte %00000110
       .byte %01000010
       .byte %00111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00111110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100 
 endif

 ifconst ROM2k
   ORG $F7FC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 16
       ORG $4FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 32
       ORG $8FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
   else
     ORG $FFFC
   endif
 endif
start
 sei
 cld
 ldy #0
 lda $D0
 cmp #$2C               ;check RAM location #1
 bne MachineIs2600
 lda $D1
 cmp #$A9               ;check RAM location #2
 bne MachineIs2600
 dey
MachineIs2600
 ldx #0
 txa
clearmem
 inx
 txs
 pha
 bne clearmem
 sty temp1
 ldx #8
 stx playfieldpos
 stx FASTFETCH
 ldx #8
 lda #224
inityloop
 sta player1y,x
 dex
 bpl inityloop

 lda #1
 sta CTRLPF
 lda INTIM
 sta RWRITE0
 lda #0
 STA DF0FRACINC
 STA DF1FRACINC
 STA DF2FRACINC
 STA DF3FRACINC
 STA DF4FRACINC
 STA DF6FRACINC
 lda #<USERSTACK
 STA DF7LOW
 lda #(>USERSTACK) & $0F
 STA DF7HI
 lda #255
 sta CALLFUNCTION ; zero-fill fetcher

   lda #>(game-1)
   pha
   lda #<(game-1)
   pha
   pha
   pha
   ldx #1
   jmp BS_jsr
;This is a modified VB kernel by Omegamatrix
;last updated Oct 21, 2014 (Ver 7)
;
;This version has a split score, two digits on the left and four on the right. Just use the "splitscore_2_4" constant to have a split score.
; - pfscore is gone for split score, but there are cycle left in the kernel to re-introduce it in the middle use PF2 and a reflected PF.
;   This would also involve modifying BB in other places (I think)


BIT_0 = (1 << 0)
BIT_1 = (1 << 1)
BIT_2 = (1 << 2)
BIT_3 = (1 << 3)
BIT_4 = (1 << 4)
BIT_5 = (1 << 5)
BIT_6 = (1 << 6)
BIT_7 = (1 << 7)

;73/74 cycle HMxx
LEFT74_15            = $70
LEFT74_14            = $60
LEFT74_13            = $50
LEFT74_12            = $40
LEFT74_11            = $30
LEFT74_10            = $20
LEFT74_9             = $10
LEFT74_8             = $00
LEFT74_7             = $F0
LEFT74_6             = $E0
LEFT74_5             = $D0
LEFT74_4             = $C0
LEFT74_3             = $B0
LEFT74_2             = $A0
LEFT74_1             = $90
NO_MO_74             = $80

;spit out some error messages and break the compile if the user hasn't set up the split score kernel.
;do this only on the second pass...
  if DASM_2ND_PASS
    ifconst splitscore_2_4
      ifnconst splitKernelVar
        ECHO "Error: Please Dim splitKernelVar = my_Var_Name to use the split score kernel"
        err
      endif
      ifnconst SPLIT_KERN_BIT
        ECHO "Error: Please const SPLIT_KERN_BIT = BIT_x to use the split score kernel"
        ECHO "       You can use 'BIT_0' to 'BIT_7'. for the bit."
        err
      endif
    endif
  endif
DASM_2ND_PASS = 1



;An alternative to above is the comment out the checking code, and hardwire the variable and bit here (below)
;splitKernelVar = $D1         ; This is the zp ram location you keep the flag for changing kernels.
;SPLIT_KERN_BIT = BIT_7       ; If this bit is set in "splitKernelVar" then the split score is drawn.


;========================================================

drawscreen
     lda #1
     sta CXCLR
     sta COLUBK ; REVENG - don't start with the lastline color

fufu
     lda INTIM
     bmi fufu

     VERTICAL_SYNC

     lda #41+128;was 37 - do more w/c code
     sta TIM64T

     ; run possible vblank bB code
     ifconst vblank_bB_code
         jsr vblank_bB_code
     endif

     ; adjust for pfpos?

     ; set zero to properly enter C code
     lda #<C_function
     sta DF0LOW
     lda #(>C_function) & $0F
     sta DF0HI
     lda #0
     sta DF0WRITE

     ; REVENG - pass the number of vsprites we want...
     ifnconst dpcspritemax
       lda #9
     else
       lda #dpcspritemax
     endif
     sta DF0WRITE

     lda player0x
     sta player0xcoll ; detect p0x colls

     ; copy RAM to fetcher for C-code
     lda #<(CcodeData + RAMcopylength)
     sta DF0LOW
     lda #(>(CcodeData + RAMcopylength)) & $0F
     sta DF0HI
     ldx #RAMcopylength-1
copy2fetcherloop
     lda RAMcopybegin,x
     sta DF0PUSH
     dex
     bpl copy2fetcherloop

     lda #255
     sta CALLFUNCTION

     ; copy modified data back (just need first 6 bytes, which is sprite sort data)
     ldx #256-19
copyfromfetcherloop
     lda DF0DATA
     sta RAMcopybegin+19,x
     inx
     bmi copyfromfetcherloop

     jsr kernel_setup

     jsr set_fetchers

     ldx #7
setloopfrac
     lda dffraclow,x
     sta DF0FRACLOW,x
     lda dffrachi,x
     sta DF0FRACHI,x
     dex
     bpl setloopfrac
     ; lda #255
     STx DF5FRACINC ; x=255 right now
     STx DF7FRACINC
     lda DF5FRACDATA ; priming read
     lda DF7FRACDATA ; priming read

     ldx SpriteGfxIndex
     lda _NUSIZ1,x ; top NUSIZ/REFP
     sta NUSIZ1
     sta REFP1

     ;REVENG - allow P0 to wrap at the top
startwrapfix
     lda #255
     sta temp2
     clc
     lda player0y
     adc player0height
     sec
     cmp player0height
     bcc skipwrapfix
     lda #0
     sta temp2
skipwrapfix

     sec
     lda #<P0GFX
     sbc player0y
     sta DF2LOW
     lda #>P0GFX
     ;sbc #0
     sbc temp2
     sta DF2HI
     lda #<(P0GFX-1)
     sta DF2TOP
     sec
     adc player0height
     sta DF2BOT

     ;REVENG - 1/2 of the COLUM0 fix. the rest is in main.c
     lda #<(P0COLOR)
     sta DF0LOW
     sta temp2
     lda #>(P0COLOR)
     sta DF0HI

     ; ball
     lda #<(P1GFX-1)
     clc
     adc bally
     sta DF3TOP
     sec
     adc ballheight
     sta DF3BOT

     ; missile0
     lda temp2
     clc
     adc missile0y
     sta DF0TOP
     sec
     adc missile0height
     sta DF0BOT


fuu
     lda INTIM
     bmi fuu
     sta WSYNC
     ldy #$80
     sty HMP0
     sty HMP1
     sty HMM0
     sty HMM1
     sty HMBL
     lda #KERNEL_LINES
     sta TIM64T
     lda #1
     sta VDELBL
     sta VDELP0

     ; missile1
     lda #<(P1COLOR-1)
     clc
     adc missile1y
     sta DF1TOP
     sec
     adc missile1height
     sta DF1BOT

     lda #0
     sta VBLANK
     sta FASTFETCH
     ;sleep 7
     lda #<DF2DATAW         ; REVENG - added so GRP0 is at TOP
     STA GRP0 ; 36 (VDEL)   ; ""
     sleep 2                ; ""

     lda #<DF0FRACDATA
     sta PF1 ; (PF1L)

     ; enter at cycle ??
loop:
     lda #<DF0DATA ;74
     STA COLUP0 ; 1
     lda #<DF1DATA ;3
loop2
     STA COLUP1 ; 6
     lda #<DF3DATA
     STA GRP1 ; 11
     lda #<DF0FLAG
     STA ENAM0 ; 16

     lda #<DF6FRACDATA
     sta COLUBK ; 21
     lda #<DF4FRACDATA
     sta COLUPF ; 26
     lda #<DF1FRACDATA
     sta PF2 ; 31 (PF2L)
loop3
     lda #<DF2DATAW
     STA GRP0 ; 36 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 41 (VDEL)
     ldx #$70 ;in case we get kernel 6
     lda #<DF2FRACDATA ;45
     sta PF2 ; 48
     sty HMP1 ; 51 ; from prev. cycle: $80=nomove
     lda #<DF3FRACDATA ;53
     sta PF1 ; 56
     lda #<DF4DATA ; 58 this is the repos info
     beq repo ;60/61
norepo     ; 60
     tay ; 62
     lda #<DF0DATA ; 64

     ldx INTIM ; 68 timed for 192 lines
     beq exitkernel; 70/71
     sta HMOVE ; 73

     STA COLUP0 ; 0
     lda #<DF1DATA ;2
     STA COLUP1 ;5
     lda #<DF3DATA
     STA GRP1 ; 10
     lda #<DF1FLAG
     STA ENAM1 ; 15
     lda #<DF0FRACDATA
     sta PF1 ; 20 (PF1L)
     lda #<DF1FRACDATA
     sta PF2 ; 25 (PF2L)
     lda #<DF2DATAW
     STA GRP0 ; 30 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 35 (VDEL)
     dey ; 37
     STY DF4PUSH ; 41
     ldy #$80 ; 43 no movement next line
     lda #<DF2FRACDATA ;45
     sta PF2 ; 48
     sty HMP1 ; 51 ; from prev. cycle: $80=nomove
     lda #<DF3FRACDATA ;53
     sta PF1 ; 56
     ifnconst DPC_kernel_options
         ;sleep 8 ; REVENG - timing is off - results in a garbled screen
         sleep 5 ; this is better
     else
         bit DPC_kernel_options
         if (DPC_kernel_options > $3F)
             bmi COLfound
         else
             bpl COLfound
         endif
     endif
     stx temp4 ; +3

getbackearly
     lda #<DF0FRACDATA ; +2
     sta PF1 ; 69 (PF1L) too early?
     JMP loop+$4000 ; 72

     ifconst DPC_kernel_options
COLfound
         lda DF0FRACDATA
         sta PF1 ; 69 (PF1L) too early?
         JMP loop+$4000 ; 72
     endif

repo
     ldy DF7FRACDATA ; 65
     lda #<DF0FRACDATA ; 67 preload PF1L for next line
     if ((>repo) > (>norepo))
         STA PF1
     else
         STA.w PF1 ; 71 ; sta.w if page doesn't wrap
     endif
     lda #<DF0DATA ;73
     STA COLUP0 ; 0
     lda #<DF1DATA
     STA COLUP1 ;5
     lda #<DF3DATA
     STA GRP1 ; 10
     lda #<DF1FLAG
     STA ENAM1 ; 15
     ; repos info holds HMMx
     jmp (DF5DATA) ; 20 grabs df6/df7=lo/hi

exitkernel     ; exit the kernel
     jsr scorekernel+$4000 ; 1
exit
     ldx #255
     stx FASTFETCH
     sta WSYNC
     lda #2
     STA VBLANK
     lda #OVERSCAN_LINES
     sta TIM64T
     sec
     lda #KERNEL_LINES
     sbc temp4
     tax
     lsr
     lsr
     sta temp3 ; div4
     lsr
     lsr
     sta temp2 ; div16
     lsr
     sta temp1 ; div32
     clc
     txa
     adc temp2
     adc temp1
     sec
     sbc temp3
     sta temp4 ; approx line of first pf coll
     RETURN

     ; jmp exit

     ; kernels resp1 23/28/33/38/43/48/53/58/63/68/73

kernel1
     sta RESP1 ; 23
     lda #<DF2DATAW
     STA GRP0 ; 28 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 33 (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 38

    jmp    JoinKernel4    ; Omega - save bytes
;      sleep 5
;      lda #<DF2FRACDATA ;45
;      sta PF2 ; 48
;      lda #<DF3FRACDATA ;50
;      sta PF1 ; 53
;      lda #<DF5FRACDATA ; NUSIZ/RESP info (OK here, GRP1 off)
;      STA NUSIZ1 ; 58
;      STA REFP1 ; 61
;      jmp getbackearly ;64

kernel2
     lda #<DF2DATAW
     STA GRP0 ; 25 (VDEL)
     sta RESP1 ;28
     lda #<DF3FLAG
     STA ENABL ; 33 (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 38

    jmp    JoinKernel4    ; Omega - save bytes
;      sleep 5
;      lda #<DF2FRACDATA;45
;      sta PF2 ; 48
;      lda #<DF3FRACDATA;50
;      sta PF1 ; 53
;      lda #<DF5FRACDATA ; NUSIZ/RESP info (OK here, GRP1 off)
;      STA NUSIZ1
;      STA REFP1
;      jmp getbackearly ;64

kernel3
     lda #<DF2DATAW
     STA GRP0 ; 25 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 30 (VDEL)
     sta RESP1 ;33
     lda #<DF1FRACDATA
     STA PF2 ; 38

    jmp    JoinKernel4    ; Omega - save bytes
;      sleep 5
;      lda #<DF2FRACDATA;45
;      sta PF2 ; 48
;      lda #<DF3FRACDATA;50
;      sta PF1 ; 53
;      lda #<DF5FRACDATA ; NUSIZ/RESP info (OK here, GRP1 off)
;      STA NUSIZ1
;      STA REFP1
;      JMP getbackearly ; 64

kernel4
     lda #<DF2DATAW
     STA GRP0 ; 25 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 30(VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     sta RESP1 ;38

     sleep 3
JoinKernel4
     sleep 2

     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta PF1 ; 53
     lda #<DF5FRACDATA ; NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1 ; 58
     STA REFP1 ; 61
     JMP getbackearly ; 64

kernel5
     lda #<DF2DATAW
     STA GRP0 ; (VDEL)
     lda #<DF3FLAG
     STA ENABL ; (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     sleep 5
     sta RESP1 ;43
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta PF1 ; 53
     lda #<DF5FRACDATA ; NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1
     STA REFP1
     JMP getbackearly ; 64

kernel6
     lda #<DF2DATAW
     STA GRP0 ; 25 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 30 (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     lda #<DF5FRACDATA ; 37 NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1 ; 40
     STA REFP1 ; 43
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta RESP1 ;53
     ; do a move right by 15
     sta PF1 ; 56
     stx HMP1 ; 59
     lda #<DF1FRACDATA
     sta PF2 ; 64 (PF2L)
     lda #<DF0FRACDATA
     sta PF1 ; 69 (PF1L) too early?
     lda #<DF0DATA ; 71
     sta HMOVE ; 74 adjust to +15 right

     STA COLUP0 ; 1
     lda #<DF1DATA
     sta COLUP1 ; 6
     lda #<DF3DATA
     STA GRP1 ; 11
     lda #<DF0FLAG
     STA ENAM0 ; 16
     lda #<DF6FRACDATA
     STA COLUBK ; 21
     lda #<DF4FRACDATA
     sta COLUPF ; 26
     sleep 2
     jmp loop3 ; 31

kernel7
     lda #<DF2DATAW
     STA GRP0 ; 25 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 30 (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     lda #<DF5FRACDATA ; 37 NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1 ; 40
     STA REFP1 ; 43
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     sleep 2
     sta RESP1 ;53
     lda #<DF3FRACDATA;55
     sta PF1 ; 58
     sleep 3
     JMP getbackearly ; 64

kernel8
     lda #<DF2DATAW
     STA GRP0 ; (VDEL)
     lda #<DF3FLAG
     STA ENABL ; (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     lda #<DF5FRACDATA ; 37 NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1 ; 40
     STA REFP1 ; 43
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta PF1 ; 53
     sleep 2
     sta RESP1 ;58
     sleep 3
     JMP getbackearly ; 64

kernel9
     lda #<DF2DATAW
     STA GRP0 ; (VDEL)
     lda #<DF3FLAG
     STA ENABL ; (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     lda #<DF5FRACDATA ; 37 NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1 ; 40
     STA REFP1 ; 43
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta PF1 ; 53
     sleep 5
     lda #<DF0FRACDATA
     sta RESP1 ;63
     sleep 3
     sta PF1 ; 69 (PF1L) too early?
     jmp loop ;72

kernel10
     lda #<DF2DATAW
     STA GRP0 ; 25 (VDEL)
     lda #<DF3FLAG
     STA ENABL ; 30 (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     lda #<DF5FRACDATA ; 37 NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1 ; 40
     STA REFP1 ; 43
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta PF1 ; 53
     sleep 6
     lda #<DF0FRACDATA
     LDX DF0DATA ; 65
     sta RESP1 ; 68
     STA PF1 ; 71
     lda #<DF1DATA ; 74
     STX COLUP0 ; 0
     jmp loop2 ; 3

kernel11
     lda #<DF2DATAW
     STA GRP0 ; (VDEL)
     lda #<DF3FLAG
     STA ENABL ; (VDEL)
     lda #<DF1FRACDATA
     STA PF2 ; 35
     lda #<DF5FRACDATA ; NUSIZ/RESP info (OK here, GRP1 off)
     STA NUSIZ1
     STA REFP1
     lda #<DF2FRACDATA;45
     sta PF2 ; 48
     lda #<DF3FRACDATA;50
     sta PF1 ; 53
     sleep 3
     lda #<DF1FRACDATA;45
     sta PF2 ; 61
     LDX DF0DATA ; 65

     lda #<DF0FRACDATA ; 67
     sta PF1 ; 70
     sta RESP1 ; 73
     STX COLUP0 ; 0
     lda #<DF1DATA ; 2
     sta COLUP1 ; 5
     lda #<DF3DATA
     STA GRP1 ; 10
     lda #<DF0FLAG
     STA ENAM0 ; 25
     lda #<DF6FRACDATA
     STA COLUBK ; 20
     lda #<DF4FRACDATA
     sta COLUPF ; 25
     sleep 3
     jmp loop3 ; 31

set_fetchers
     lda dflow
     sta DF0LOW
     lda dfhigh
     sta DF0HI

     lda dflow+1
     sta DF1LOW
     lda dfhigh+1
     sta DF1HI

     lda dflow+2
     sta DF2LOW
     lda dfhigh+2
     sta DF2HI

set_fetchers36 ; sets just 3-6
     lda dflow+3
     sta DF3LOW
     lda dfhigh+3
     sta DF3HI

     lda dflow+4
     sta DF4LOW
     lda dfhigh+4
     sta DF4HI

     lda dflow+5
     sta DF5LOW
     lda dfhigh+5
     sta DF5HI

     lda dflow+6
     sta DF6LOW
     lda dfhigh+6
     sta DF6HI

     rts

     ;9d bad
     ; the below isn't quite right
     ;DF0DATA: COLUP0
     ;DF1DATA: COLUP1
     ;DF2DATAW: GRP0
     ;DF3DATA: GRP1
     ;DF4DATA: 2lk lines until repos/HMP1
     ;DF5DATA: low byte of repo kernels (xpos mod 15)
     ;DF6DATA: High byte of repo kernels (x pos div 15)
     ;DF7DATA: Programmer's stack
     ;DF0FRACDATA: PF1L
     ;DF1FRACDATA: PF2L
     ;DF4FRACDATA: COLUPF
     ;DF2FRACDATA: PF2R
     ;DF3FRACDATA: PF2L
     ;DF5FRACDATA: Sprite NUSIZ1/REFP1 (only during repos)
     ;DF6FRACDATA: COLUBK
     ;DF7FRACDATA: HMP1
     ;DF3FLAG: kernel exit loop ?? (use flags instead?)
     ;DF0FLAG: ENAM0
     ;DF1FLAG: ENAM1
     ;DF3FLAG: ENABL

fetcher_address_table
kernello
     .byte <kernel1
     .byte <kernel2
     .byte <kernel3
     .byte <kernel4
     .byte <kernel5
     .byte <kernel6
     .byte <kernel7
     .byte <kernel8
     .byte <kernel9
     .byte <kernel10
     .byte <kernel11
kernelhi
     .byte >kernel1
     .byte >kernel2
     .byte >kernel3
     .byte >kernel4
     .byte >kernel5
     .byte >kernel6
     .byte >kernel7
     .byte >kernel8
     .byte >kernel9
     .byte >kernel10
     .byte >kernel11
dflow
     .byte <P0COLOR
     .byte <P1COLOR
     .byte <P0GFX
     .byte <P1GFX
     .byte <P1SKIP
     .byte <JUMPTABLELO
     .byte <JUMPTABLEHI
     .byte <USERSTACK
dfhigh
     .byte (>P0COLOR) & $0F
     .byte (>P1COLOR) & $0F
     .byte (>P0GFX) & $0F
     .byte (>P1GFX) & $0F
     .byte (>P1SKIP) & $0F
     .byte (>JUMPTABLELO) & $0F
     .byte (>JUMPTABLEHI) & $0F
     .byte (>USERSTACK) & $0F
dffraclow
     .byte <PF1L
     .byte <PF2L
     .byte <PF1R
     .byte <PF2R
     .byte <PFCOLS
     .byte <NUSIZREFP
     .byte <BKCOLS
     .byte <P1HMP
dffrachi
     .byte (>PF1L) & $0F
     .byte (>PF2L) & $0F
     .byte (>PF1R) & $0F
     .byte (>PF2R) & $0F
     .byte (>PFCOLS) & $0F
     .byte (>NUSIZREFP) & $0F
     .byte (>BKCOLS) & $0F
     .byte (>P1HMP) & $0F
scorepointer
     .byte <scoretable
     .byte ((>scoretable) & $0f) | (((>scoretable) / 2) & $70)
scoresetup     ; pointers to digit graphics
     .byte <scoredata
     .byte (>scoredata) & $0F
Hmval; 112 wuz first
     .byte 96, 80, 64, 48, 32, 16, 1, 240
Hmval74
     .byte 224, 208, 192, 176, 160, 144, 128
     .byte 96, 80, 64, 48, 32, 16, 1, 240, 224, 208, 192, 176, 160, 144, 128, 96
     .byte 80, 64, 48, 32, 16, 1, 240, 224, 208, 192, 176, 160, 144, 128, 96, 80
     .byte 64, 48, 32, 16, 1, 240, 224, 208, 192, 176, 160, 144, 128, 96, 80, 64
     .byte 48, 32, 16, 1, 240, 224, 208, 192, 176, 160, 144, 128, 96, 80, 64, 48
     .byte 32, 16, 1, 240, 224, 208, 192, 176, 160, 144, 128, 96, 80, 64, 48, 32
     .byte 16, 1, 240, 224, 208, 192, 176, 160, 144, 128, 96, 80, 64, 48, 32, 16
     .byte 1, 240, 224, 208, 192, 176, 160, 144, 128, 96, 80, 64, 48, 32, 16, 1
     .byte 240, 224, 208, 192, 176, 160, 144, 128, 96, 80, 64, 48, 32, 16, 1, 240
     .byte 224, 208, 192, 176, 160, 144, 128, 96, 80, 64, 48, 32, 16, 1, 240, 224, 208, 192
     .byte 176,160,144,128,16,1,240,224


kernel_setup
     ;--position P0, top P1, M0, M1, BL
     ldx #0 ; first sprite displayed
     lda SpriteGfxIndex,x
     tax
     lda player1x,x
     cmp #160
     bcc nostorep1
     cmp #208
     bcs ksadjustdown
     ; 160-208: minus 160
     ;add 160 is like minus 96
     ; so minus 64
     sbc #63 ;cc
ksadjustdown
     ; 209-255: add 160
     adc #159 ; cs
     sta player1x,x
nostorep1
     sta WSYNC
     ldx #4
     sta topP1x ; cache top p1
HorPosLoop
     lda player0x,X
     sec
DivideLoop
     sbc #15
     bcs DivideLoop
     sleep 4
     sta RESP0,X
     sta WSYNC
     dex ;2
     bpl HorPosLoop ;4/5

     ldy player0x ; 7
     lda Hmval,y ; 11
     sta HMP0 ; 14

     ldy player0x+1
     lda Hmval,y
     sta HMP0+1 ; 24

     ldy player0x+2
     lda Hmval,y
     sta HMP0+2 ; 34

     ldy player0x+3
     lda Hmval,y
     sta HMP0+3 ; 44

     ldy player0x+4
     lda Hmval,y
     sta HMP0+4 ; 54

     sta WSYNC
     sta HMOVE

myrts
     rts


pfsetup

     sty temp1
     sta temp2
     stx temp3
     ldx #3
pfsetupp
     lda dffraclow,x
     sta DF0LOW,x
     lda dffrachi,x
     sta DF0HI,x
     lda temp2
     sta PARAMETER
     lda temp3
     sta PARAMETER
     stx PARAMETER
     sty PARAMETER
     LDA #1
     sta CALLFUNCTION
     clc
     lda temp2
     adc temp1
     sta temp2
     lda temp3
     adc #0
     sta temp3
     dex
     bpl pfsetupp
     RETURN


scorekernel
     ifconst minikernel
         ;; disable fast fetch, call the minikernel, and re-enable fast fetch
         lda #255
         sta FASTFETCH
         jsr minikernel
         lda #0
         sta.w FASTFETCH
     endif
;      ldx scorecolor   ; Omega - removed
;      stx COLUP0       ; Omega - removed
;      stx COLUP1       ; Omega - removed
     ldx #0
     STx PF1
     stx REFP0
     stx REFP1
     STx GRP0
     STx GRP1
     STx PF2
     stx HMCLR
     stx ENAM0
     stx ENAM1
     stx ENABL


     ifconst pfscore
         lda pfscorecolor
         sta COLUPF
     endif

     ifconst noscore
         rts
     endif

;      sta HMCLR       ; Omega - moved
;      ldx #$f0
;      stx HMP0

     ; set up fetchers 0-5 to handle score digits
     ldx #<(scoredata)
     stx DF6LOW
     ldx #(>(scoredata)) & $0F
     stx DF6HI
     ldx #<(scoredata+8)
     stx DF0LOW
     ldx #(>(scoredata+8)) & $0F
     stx DF0HI
     ldx #<(scoredata+16)
     stx DF1LOW
     ; cycle 0??
     ldx #(>(scoredata+16)) & $0F
     stx DF1HI
     ldx #<(scoredata+24)
     stx DF2LOW
     ldx #(>(scoredata+24)) & $0F
     stx DF2HI



  ifconst splitscore_2_4
    lda    splitKernelVar    ; Omega - new code
    and    #SPLIT_KERN_BIT
    cmp    #SPLIT_KERN_BIT   ; carry now set/cleared for branching later

    ldx    #LEFT74_12
    stx    HMP1
    ldx    #LEFT74_11
  ELSE
    clc                      ; default to using centered score display
    ldx   #$F0               ; might be able to use TSX
  ENDIF
    stx   HMP0

    ldx    #3                ; Omega - can't use LDA #IMM for DPC+
    txa
    ldx    #0                ; Omega - moved up from below
    ldy    #7                ; Omega - moved up from below
    sty    temp1             ; Omega - moved up from below


                             ; Omega - now much more cycles

    sta    WSYNC
;----------------------------------------
    stx    GRP0                  ;3  @3
    stx    GRP1                  ;3  @6        seems to be needed because of vdel

    ldx    #<(scoredata+32)      ;2  @8
    stx    DF3LOW                ;4  @12
    ldx    #(>(scoredata+32)) & $0F ;2  @14
    stx    DF3HI                 ;4  @18
    ldx    #<(scoredata+40)      ;2  @20
    stx    DF4LOW                ;4  @24
    ldx    #(>(scoredata+40)) & $0F ;2  @26
    stx    DF4HI                 ;4  @30
    sty    VDELP0                ;3  @33
    sta    NUSIZ1                ;3  @36       A=3
    sta    NUSIZ0                ;3  @39
    sta    RESP0                 ;3  @42
    sta    RESP1                 ;3  @45
    sta.w  VDELP1                ;4  @49
    ldx    #<(scoredata+48)      ;2  @51
    stx    DF5LOW                ;4  @55
    ldx    #(>(scoredata+48)) & $0F ;2  @57
    bcc    DrawRegularScore      ;2 @59/60

DrawSplitScore
    sta    RESP0                 ;3  @62       Omega - RESP0 and RESP1 moved here to shift graphics far to the right
    sta    RESP1                 ;3  @65
    stx    DF5HI                 ;4  @69
    sta.w  HMOVE                 ;3  @73

loopSplitScore
    lda    #<DF6DATA             ;2  @75
;---------------------------------------
    sta    COLUP0                ;3  @2
    sta    COLUP1                ;3  @5
    lda    #<DF1DATA             ;2  @7
    sta    GRP0                  ;3  @10
    lda    #<DF0DATA             ;2  @12
    sta    GRP1                  ;3  @15
    lda    #<DF3DATA             ;2  @17
    sta    GRP0                  ;3  @20
    ldx    #4                    ;2  @22   TWO_COPIES_WIDE
    stx    NUSIZ0                ;3  @25
    stx    NUSIZ1                ;3  @28
    ldy    DF5DATA               ;4  @32
    lda    #<DF4DATA             ;2  @34
    sleep 4                      ;4  @38
    ldx    #1                    ;2  @40   TWO_COPIES_CLOSE
    stx    NUSIZ0                ;3  @43
    stx    NUSIZ1                ;3  @46
    ldx    DF2DATA               ;4  @50
    dec    temp1                 ;5  @55
    stx    GRP1                  ;3  @58
    sty    GRP0                  ;3  @61
    sta    GRP1                  ;3  @64
    sta    GRP0                  ;3  @67
    sleep 3                      ;3  @70
    bpl    loopSplitScore        ;2 @72/73

FinishScoreRoutine
    ldx    #0                    ;2  @74..1    worse case
;---------------------------------------
    stx    PF1                   ;3  @4
    stx    GRP0                  ;3  @7
    stx    GRP1                  ;3  @10
    stx    VDELP0                ;3  @13
    stx    VDELP1                ;3  @16
    stx    NUSIZ0                ;3  @19
    stx    NUSIZ1                ;3  @22
    rts                          ;6  @28



DrawRegularScore
    stx    DF5HI                 ;4  @64
    nop                          ;2  @66
    nop                          ;2  @68
    nop                          ;2  @70
    sta   HMOVE                  ;3  @73

scoreloop
    lda    #<DF6DATA             ;2  @75
;---------------------------------------
    sta    COLUP0                ;3  @2
    sta    COLUP1                ;3  @5
    lda    #<DF1DATA             ;2  @7
    sta    GRP0                  ;3  @10
    lda    #<DF0DATA             ;2  @12
    sta    GRP1                  ;3  @15
    lda    #<DF3DATA             ;2  @17
    sta    GRP0                  ;3  @20

     ; REVENG - rearranged to correct pf write timing and A register overwrite
  ifconst pfscore
    lda    pfscore1              ;3  @23
    sta    PF1                   ;3  @26
  else
    sleep 6
  endif

joinCenteredScore
    ldx    DF2DATA               ;4  @30
    ldy    DF5DATA               ;4  @34
    lda    #<DF4DATA             ;2  @36
    dec    temp1                 ;5  @41
    stx    GRP1                  ;3  @44
    sty    GRP0                  ;3  @47
    sta    GRP1                  ;3  @50
    sta    GRP0                  ;3  @53

  ifconst pfscore
    lda    pfscore2              ;3  @56
    sta    PF1                   ;3  @59
  else
    sleep 6
  endif

    ldy    temp1                 ;3  @62
    sleep 8
                                 ;8  @70
    bpl    scoreloop             ;2 @72/73
    bmi    FinishScoreRoutine    ;3  @75     always branch


game
.L00 ;  set kernel DPC + 

.L01 ;  set tv ntsc

.L02 ;  set optimization speed

.L03 ;  set optimization inlinerand

.L04 ;  set kernel_options collision(playfield,player1)

DPC_kernel_options = 	CXP1FB+$40
.
 ; 

.L05 ;  goto __Bank_2 bank2

 sta temp7
 lda #>(.__Bank_2-1)
 pha
 lda #<(.__Bank_2-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.
 ; 

.L06 ;  bank 2

 if ECHO1
 echo "    ",[(start_bank1 - *)]d , "bytes of ROM space left in bank 1")
 endif
ECHO1 = 1
 ORG $1FF4-bscode_length
 RORG $1FF4-bscode_length
start_bank1 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha
 pha
 txa
 pha
 tsx
 if bankswitch != 64
   lda 4,x ; get high byte of return address
   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 ORG $1FFC
 RORG $1FFC
 .word start_bank1
 .word start_bank1
 ORG $2000
 RORG $3000
HMdiv
  .byte 0, 0, 0, 0, 0, 0, 0
  .byte 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2
  .byte 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3
  .byte 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4
  .byte 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5
  .byte 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6
  .byte 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7
  .byte 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8
  .byte 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9
  .byte 9, 9, 9, 9, 9, 9, 9, 10, 10, 10, 10, 10, 10, 10, 10, 10
  .byte 10,10,10,10,10,10,0,0,0
.L07 ;  temp1 = temp1

	LDA temp1
	STA temp1
.
 ; 

.
 ; 

.__Bank_2
 ; __Bank_2

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L08 ;  const splitscore_2_4  =  1

.L09 ;  const SPLIT_KERN_BIT  =  BIT_7

.L010 ;  dim pacer  =  a

.L011 ;  dim flags  =  b

.L012 ;  dim splitKernelVar  =  b

;.frame_locked.b{0}.
.L013 ;  def frame_locked = b{0}

;.stair_locked.b{1}.
.L014 ;  def stair_locked = b{1}

;.is_left.b{2}.
.L015 ;  def is_left = b{2}

;.hit_middle.b{3}.
.L016 ;  def hit_middle = b{3}

;.going_up.b{4}.
.L017 ;  def going_up = b{4}

;.split_score.b{7}.
.L018 ;  def split_score = b{7}

.L019 ;  dim frame  =  c

.L020 ;  dim player_horiz  =  player0x.d

.L021 ;  dim level  =  e

.L022 ;  dim room_index  =  f

.L023 ;  dim room  =  g

.L024 ;  dim stair_index  =  h

.
 ; 

.L025 ;  dim sc1  =  score

.L026 ;  dim sc2  =  score + 1

.L027 ;  dim sc3  =  score + 2

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.__Start_Restart
 ; __Start_Restart

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L028 ;  drawscreen

 sta temp7
 lda #>(ret_point1-1)
 pha
 lda #<(ret_point1-1)
 pha
 lda #>(drawscreen-1)
 pha
 lda #<(drawscreen-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #1
 jmp BS_jsr
ret_point1
.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L029 ;  pfclear

	lda #<C_function
	sta DF0LOW
	lda #(>C_function) & $0F
	sta DF0HI
	ldx #28
	stx DF0WRITE
	LDA #0
	sta DF0WRITE
	lda #255
	sta CALLFUNCTION
.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L030 ;  AUDV0  =  0  :  AUDV1  =  0

	LDA #0
	STA AUDV0
	STA AUDV1
.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L031 ;  a  =  0  :  b  =  0  :  c  =  0  :  d  =  0  :  e  =  0  :  f  =  0  :  g  =  0  :  h  =  0  :  i  =  0

	LDA #0
	STA a
	STA b
	STA c
	STA d
	STA e
	STA f
	STA g
	STA h
	STA i
.L032 ;  j  =  0  :  k  =  0  :  l  =  0  :  m  =  0  :  n  =  0  :  o  =  0  :  p  =  0  :  q  =  0  :  r  =  0

	LDA #0
	STA j
	STA k
	STA l
	STA m
	STA n
	STA o
	STA p
	STA q
	STA r
.L033 ;  s  =  0  :  t  =  0  :  u  =  0  :  v  =  0  :  w  =  0  :  x  =  0  :  y  =  0  :  z  =  0

	LDA #0
	STA s
	STA t
	STA u
	STA v
	STA w
	STA x
	STA y
	STA z
.
 ; 

.L034 ;  player0x  =  38 :  player0y  =  138

	LDA #38
	STA player0x
	LDA #138
	STA player0y
.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L035 ;  gosub __Set_Level bank3

 sta temp7
 lda #>(ret_point2-1)
 pha
 lda #<(ret_point2-1)
 pha
 lda #>(.__Set_Level-1)
 pha
 lda #<(.__Set_Level-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #3
 jmp BS_jsr
ret_point2
.
 ; 

.__Main_Loop
 ; __Main_Loop

.
 ; 

.L036 ;  gosub __Pacer_Tick

 jsr .__Pacer_Tick

.L037 ;  if stair_index  <>  255  &&  !stair_locked then gosub __Stair_Check

	LDA stair_index
	CMP #255
     BEQ .skipL037
.condpart0
	LDA b
	AND #2
	BNE .skip0then
.condpart1
 jsr .__Stair_Check

.skip0then
.skipL037
.L038 ;  gosub __Grinch_Move

 jsr .__Grinch_Move

.L039 ;  gosub __Set_Grinch_State

 jsr .__Set_Grinch_State

.L040 ;  if is_left then REFP0  =  8

	LDA b
	AND #4
	BEQ .skipL040
.condpart2
	LDA #8
	STA REFP0
.skipL040
.L041 ;  if joy0fire then split_score  =  !split_score

 bit INPT4
	BMI .skipL041
.condpart3
	LDA b
	AND #128
  PHP
	LDA b
	AND #127
  PLP
	.byte $D0, $02
	ORA #128
	STA b
.skipL041
.L042 ;  if !split_score then goto __Draw_Main_Score

	BIT b
	BMI .skipL042
.condpart4
 jmp .__Draw_Main_Score

.skipL042
.
 ; 

.L043 ;  scorecolors:

	lda #<scoredata
	STA DF0LOW
	lda #((>scoredata) & $0f)
	STA DF0HI
	lda #$46

	sta DF0WRITE
	lda #$44

	sta DF0WRITE
	lda #$1E

	sta DF0WRITE
	lda #$1E

	sta DF0WRITE
	lda #$1C

	sta DF0WRITE
	lda #$1C

	sta DF0WRITE
	lda #$1A

	sta DF0WRITE
	lda #$1A

	sta DF0WRITE
.L044 ;  sc1  =  $12

	LDA #$12
	STA sc1
.L045 ;  sc2  =  $34

	LDA #$34
	STA sc2
.L046 ;  sc3  =  $56

	LDA #$56
	STA sc3
.
 ; 

.L047 ;  goto __Main_Draw

 jmp .__Main_Draw

.__Draw_Main_Score
 ; __Draw_Main_Score

.L048 ;  scorecolors:

	lda #<scoredata
	STA DF0LOW
	lda #((>scoredata) & $0f)
	STA DF0HI
	lda #$46

	sta DF0WRITE
	lda #$44

	sta DF0WRITE
	lda #$AE

	sta DF0WRITE
	lda #$AE

	sta DF0WRITE
	lda #$AC

	sta DF0WRITE
	lda #$AC

	sta DF0WRITE
	lda #$AA

	sta DF0WRITE
	lda #$AA

	sta DF0WRITE
.L049 ;  sc1  =  $56

	LDA #$56
	STA sc1
.L050 ;  sc2  =  $78

	LDA #$78
	STA sc2
.L051 ;  sc3  =  $90

	LDA #$90
	STA sc3
.
 ; 

.__Main_Draw
 ; __Main_Draw

.L052 ;  DF0FRACINC  =  32 :  DF1FRACINC  =  32 :  DF2FRACINC  =  32 :  DF3FRACINC  =  32

	LDA #32
	STA DF0FRACINC
	STA DF1FRACINC
	STA DF2FRACINC
	STA DF3FRACINC
.L053 ;  DF4FRACINC  =  64

	LDA #64
	STA DF4FRACINC
.L054 ;  DF6FRACINC  =  0

	LDA #0
	STA DF6FRACINC
.L055 ;  drawscreen

 sta temp7
 lda #>(ret_point3-1)
 pha
 lda #<(ret_point3-1)
 pha
 lda #>(drawscreen-1)
 pha
 lda #<(drawscreen-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #1
 jmp BS_jsr
ret_point3
.
 ; 

.L056 ;  goto __Main_Loop

 jmp .__Main_Loop

.
 ; 

.__Pacer_Tick
 ; __Pacer_Tick

.L057 ;  pacer  =  pacer  +  1

	INC pacer
.L058 ;  if pacer  >=  16 then pacer  =  0

	LDA pacer
	CMP #16
     BCC .skipL058
.condpart5
	LDA #0
	STA pacer
.skipL058
.L059 ;  return thisbank

	RTS
.
 ; 

.__Stair_Check
 ; __Stair_Check

.L060 ;  temp1  =  stair_index  *  6

	LDA stair_index
	asl
	clc
	adc stair_index
	asl
	STA temp1
.L061 ;  temp2  =  temp1  +  1

	LDA temp1
	CLC
	ADC #1
	STA temp2
.L062 ;  temp3  =  stair_table[temp1] :  temp4  =  stair_table[temp2]

	LDX temp1
	LDA stair_table,x
	STA temp3
	LDX temp2
	LDA stair_table,x
	STA temp4
.L063 ;  temp6  =  temp1  +  5 :  temp6  =  stair_table[temp6]

	LDA temp1
	CLC
	ADC #5
	STA temp6
	LDX temp6
	LDA stair_table,x
	STA temp6
.L064 ;  if player0y  =  temp4  &&  player0x  >=  temp3  &&  player0x  <=  temp3  +  2  &&  joy0up then stair_locked  =  1 :  is_left  =  temp6{3} :  going_up  =  1

	LDA player0y
	CMP temp4
     BNE .skipL064
.condpart6
	LDA player0x
	CMP temp3
     BCC .skip6then
.condpart7
; complex condition detected
	LDA temp3
	CLC
	ADC #2
; todo: this LDA is spurious and should be prevented ->	LDA  1,x
	CMP player0x
     BCC .skip7then
.condpart8
 lda #$10
 bit SWCHA
	BNE .skip8then
.condpart9
	LDA b
	ORA #2
	STA b
	LDA temp6
	AND #8
  PHP
	LDA b
	AND #251
  PLP
	.byte $F0, $02
	ORA #4
	STA b
	LDA b
	ORA #16
	STA b
.skip8then
.skip7then
.skip6then
.skipL064
.
 ; 

.L065 ;  temp5  =  temp1  +  2

	LDA temp1
	CLC
	ADC #2
	STA temp5
.L066 ;  temp2  =  temp1  +  3

	LDA temp1
	CLC
	ADC #3
	STA temp2
.L067 ;  temp3  =  stair_table[temp5] :  temp4  =  stair_table[temp2]

	LDX temp5
	LDA stair_table,x
	STA temp3
	LDX temp2
	LDA stair_table,x
	STA temp4
.L068 ;  if player0y  =  temp4  &&  player0x  >=  temp3  &&  player0x  <=  temp3  +  2  &&  joy0down then stair_locked  =  1 :  is_left  =  temp6{3} :  going_up  =  0

	LDA player0y
	CMP temp4
     BNE .skipL068
.condpart10
	LDA player0x
	CMP temp3
     BCC .skip10then
.condpart11
; complex condition detected
	LDA temp3
	CLC
	ADC #2
; todo: this LDA is spurious and should be prevented ->	LDA  1,x
	CMP player0x
     BCC .skip11then
.condpart12
 lda #$20
 bit SWCHA
	BNE .skip12then
.condpart13
	LDA b
	ORA #2
	STA b
	LDA temp6
	AND #8
  PHP
	LDA b
	AND #251
  PLP
	.byte $F0, $02
	ORA #4
	STA b
	LDA b
	AND #239
	STA b
.skip12then
.skip11then
.skip10then
.skipL068
.L069 ;  return thisbank

	RTS
.
 ; 

.__Stair_Update
 ; __Stair_Update

.L070 ;  temp3  =  temp1  +  4 :  temp3  =  stair_table[temp3]

	LDA temp1
	CLC
	ADC #4
	STA temp3
	LDX temp3
	LDA stair_table,x
	STA temp3
.L071 ;  if player0y  =  temp3  &&  !hit_middle then hit_middle  =  1 :  is_left  =  !is_left

	LDA player0y
	CMP temp3
     BNE .skipL071
.condpart14
	LDA b
	AND #8
	BNE .skip14then
.condpart15
	LDA b
	ORA #8
	STA b
	LDA b
	AND #4
  PHP
	LDA b
	AND #251
  PLP
	.byte $D0, $02
	ORA #4
	STA b
.skip14then
.skipL071
.L072 ;  if player0y  <>  temp3  &&  hit_middle then hit_middle  =  0

	LDA player0y
	CMP temp3
     BEQ .skipL072
.condpart16
	LDA b
	AND #8
	BEQ .skip16then
.condpart17
	LDA b
	AND #247
	STA b
.skip16then
.skipL072
.
 ; 

.L073 ;  temp2  =  temp1  +  1 :  temp2  =  stair_table[temp2]

	LDA temp1
	CLC
	ADC #1
	STA temp2
	LDX temp2
	LDA stair_table,x
	STA temp2
.L074 ;  temp3  =  temp1  +  3 :  temp3  =  stair_table[temp3]

	LDA temp1
	CLC
	ADC #3
	STA temp3
	LDX temp3
	LDA stair_table,x
	STA temp3
.L075 ;  if !joy0down goto __Not_Down

 lda #$20
 bit SWCHA
	bne .__Not_Down
 if ( (((((#>*)&$1f)*256)|(#<.__Not_Down))>=bankswitch_hotspot) && (((((#>*)&$1f)*256)|(#<.__Not_Down))<=(bankswitch_hotspot+bs_mask)) )
   echo "WARNING: branch near the end of bank 2 may accidentally trigger a bankswitch. Reposition code there if bad things happen."
 endif
.L076 ;  if player0y  <  temp2 then player0y  =  player0y  +  1 else stair_locked  =  0 :  goto __Walking

	LDA player0y
	CMP temp2
     BCS .skipL076
.condpart18
	INC player0y
 jmp .skipelse0
.skipL076
	LDA b
	AND #253
	STA b
 jmp .__Walking

.skipelse0
.L077 ;  if going_up then going_up  =  0 :  is_left  =  !is_left

	LDA b
	AND #16
	BEQ .skipL077
.condpart19
	LDA b
	AND #239
	STA b
	LDA b
	AND #4
  PHP
	LDA b
	AND #251
  PLP
	.byte $D0, $02
	ORA #4
	STA b
.skipL077
.L078 ;  gosub __Stair_Move

 jsr .__Stair_Move

.L079 ;  return thisbank

	RTS
.
 ; 

.__Not_Down
 ; __Not_Down

.L080 ;  if !joy0up then return thisbank

 lda #$10
 bit SWCHA
	BEQ .skipL080
.condpart20
	RTS
.skipL080
.L081 ;  if player0y  >  temp3 then player0y  =  player0y  -  1 else stair_locked  =  0 :  goto __Walking

	LDA temp3
	CMP player0y
     BCS .skipL081
.condpart21
	DEC player0y
 jmp .skipelse1
.skipL081
	LDA b
	AND #253
	STA b
 jmp .__Walking

.skipelse1
.L082 ;  if !going_up then going_up  =  1 :  is_left  =  !is_left

	LDA b
	AND #16
	BNE .skipL082
.condpart22
	LDA b
	ORA #16
	STA b
	LDA b
	AND #4
  PHP
	LDA b
	AND #251
  PLP
	.byte $D0, $02
	ORA #4
	STA b
.skipL082
.L083 ;  gosub __Stair_Move

 jsr .__Stair_Move

.L084 ;  return thisbank

	RTS
.
 ; 

.__Grinch_Move
 ; __Grinch_Move

.L085 ;  gosub __Stair_Check

 jsr .__Stair_Check

.
 ; 

.L086 ;  temp2  =  pacer  &  1

	LDA pacer
	AND #1
	STA temp2
.L087 ;  if pacer  >=  14 then frame_locked  =  0 :  return thisbank

	LDA pacer
	CMP #14
     BCC .skipL087
.condpart23
	LDA b
	AND #254
	STA b
	RTS
.skipL087
.L088 ;  if !temp2 then return thisbank

	LDA temp2
	BNE .skipL088
.condpart24
	RTS
.skipL088
.L089 ;  if !stair_locked then goto __Walking

	LDA b
	AND #2
	BNE .skipL089
.condpart25
 jmp .__Walking

.skipL089
.
 ; 

.L090 ;  if joy0up  ||  joy0down then gosub __Stair_Update :  temp2  =  1 else temp2  =  0

 lda #$10
 bit SWCHA
	BNE .skipL090
.condpart26
 jmp .condpart27
.skipL090
 lda #$20
 bit SWCHA
	BNE .skip9OR
.condpart27
 jsr .__Stair_Update
	LDA #1
	STA temp2
 jmp .skipelse2
.skip9OR
	LDA #0
	STA temp2
.skipelse2
.L091 ;  goto __Walking_Anim

 jmp .__Walking_Anim

.
 ; 

.__Walking
 ; __Walking

.L092 ;  temp2  =  0

	LDA #0
	STA temp2
.L093 ;  if !joy0left then goto __Not_Left

 bit SWCHA
	BVC .skipL093
.condpart28
 jmp .__Not_Left

.skipL093
.L094 ;  temp3  =  player0x  -  1  +  19 :  temp3  =  temp3  /  16 :  temp3  =  temp3  -  2 :  temp3  =  and_table[temp3]

; complex statement detected
	LDA player0x
	SEC
	SBC #1
	CLC
	ADC #19
	STA temp3
	LDA temp3
	lsr
	lsr
	lsr
	lsr
	STA temp3
	LDA temp3
	SEC
	SBC #2
	STA temp3
	LDX temp3
	LDA and_table,x
	STA temp3
.L095 ;  if player0y  <  80 then temp5  =  room_collisions_top[room] :  temp5  =  temp5  &  temp3 else temp5  =  room_collisions_bottom[room] :  temp5  =  temp5  &  temp3

	LDA player0y
	CMP #80
     BCS .skipL095
.condpart29
	LDX room
	LDA room_collisions_top,x
	STA temp5
	LDA temp5
	AND temp3
	STA temp5
 jmp .skipelse3
.skipL095
	LDX room
	LDA room_collisions_bottom,x
	STA temp5
	LDA temp5
	AND temp3
	STA temp5
.skipelse3
.L096 ;  if !temp5 then player0x  =  player0x  -  1 :  temp2  =  1 :  is_left  =  1

	LDA temp5
	BNE .skipL096
.condpart30
	DEC player0x
	LDA #1
	STA temp2
	LDA b
	ORA #4
	STA b
.skipL096
.L097 ;  goto __Walking_Anim

 jmp .__Walking_Anim

.
 ; 

.__Not_Left
 ; __Not_Left

.L098 ;  if !joy0right then goto __Walking_Anim

 bit SWCHA
	BPL .skipL098
.condpart31
 jmp .__Walking_Anim

.skipL098
.L099 ;  temp3  =  player0x  +  1  +  19 :  temp3  =  temp3  /  16 :  temp3  =  temp3  -  2 :  temp3  =  and_table[temp3]

; complex statement detected
	LDA player0x
	CLC
	ADC #1
	CLC
	ADC #19
	STA temp3
	LDA temp3
	lsr
	lsr
	lsr
	lsr
	STA temp3
	LDA temp3
	SEC
	SBC #2
	STA temp3
	LDX temp3
	LDA and_table,x
	STA temp3
.L0100 ;  if player0y  <  80 then temp5  =  room_collisions_top[room] :  temp5  =  temp5  &  temp3 else temp5  =  room_collisions_bottom[room] :  temp5  =  temp5  &  temp3

	LDA player0y
	CMP #80
     BCS .skipL0100
.condpart32
	LDX room
	LDA room_collisions_top,x
	STA temp5
	LDA temp5
	AND temp3
	STA temp5
 jmp .skipelse4
.skipL0100
	LDX room
	LDA room_collisions_bottom,x
	STA temp5
	LDA temp5
	AND temp3
	STA temp5
.skipelse4
.L0101 ;  if !temp5 then player0x  =  player0x  +  1 :  temp2  =  1 :  is_left  =  0

	LDA temp5
	BNE .skipL0101
.condpart33
	INC player0x
	LDA #1
	STA temp2
	LDA b
	AND #251
	STA b
.skipL0101
.
 ; 

.__Walking_Anim
 ; __Walking_Anim

.L0102 ;  if temp2  &&  !frame_locked then frame_locked  =  1 :  frame  =  frame  +  1 :  frame  =  frame  &  3 :  frame  =  frame  +  4

	LDA temp2
	BEQ .skipL0102
.condpart34
	LDA b
	LSR
	BCS .skip34then
.condpart35
	LDA b
	ORA #1
	STA b
	INC frame
	LDA frame
	AND #3
	STA frame
	LDA frame
	CLC
	ADC #4
	STA frame
.skip34then
.skipL0102
.L0103 ;  if !temp2 then frame  =  0

	LDA temp2
	BNE .skipL0103
.condpart36
	LDA #0
	STA frame
.skipL0103
.__Skip_Move
 ; __Skip_Move

.L0104 ;  return thisbank

	RTS
.
 ; 

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.L0105 ;  data stair_table

	JMP .skipL0105
stair_table
	.byte    68, 138, 64, 58, 96, 8

.skipL0105
.
 ; 

.L0106 ;  data and_table

	JMP .skipL0106
and_table
	.byte    128, 64, 32, 16, 8, 4, 2, 1

.skipL0106
.
 ; 

.L0107 ;  data room_collisions_top

	JMP .skipL0107
room_collisions_top
	.byte    %11100000

.skipL0107
.
 ; 

.L0108 ;  data room_collisions_bottom

	JMP .skipL0108
room_collisions_bottom
	.byte    %00000001

.skipL0108
.
 ; 

.__Stair_Move
 ; __Stair_Move

.L0109 ;  if is_left then player_horiz  =  player_horiz  -  0.55 else player_horiz  =  player_horiz  +  0.55

	LDA b
	AND #4
	BEQ .skipL0109
.condpart37
	LDA d
	SEC 
	SBC #140
	STA d
	LDA player_horiz
	SBC #0
	STA player_horiz
 jmp .skipelse5
.skipL0109
	LDA d
	CLC 
	ADC #140
	STA d
	LDA player_horiz
	ADC #0
	STA player_horiz
.skipelse5
.L0110 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.__Set_Grinch_State
 ; __Set_Grinch_State

.
 ; 

.L0111 ;  player0color:

	LDX #<playercolorL0111_0
	STX player0color
	LDA #((>playercolorL0111_0) & $0f) | (((>playercolorL0111_0) / 2) & $70)
	STA player0color+1
.
 ; 

.L0112 ;  on frame goto __Grinch_Stand __Grinch_Stand __Grinch_Stand __Grinch_Stand __Grinch_WalkA __Grinch_WalkB __Grinch_WalkA __Grinch_WalkC

	LDX frame
	LDA .L0112jumptablehi,x
	PHA
	LDA .L0112jumptablelo,x
	PHA
	RTS
.L0112jumptablehi
	.byte >(.__Grinch_Stand-1)
	.byte >(.__Grinch_Stand-1)
	.byte >(.__Grinch_Stand-1)
	.byte >(.__Grinch_Stand-1)
	.byte >(.__Grinch_WalkA-1)
	.byte >(.__Grinch_WalkB-1)
	.byte >(.__Grinch_WalkA-1)
	.byte >(.__Grinch_WalkC-1)
.L0112jumptablelo
	.byte <(.__Grinch_Stand-1)
	.byte <(.__Grinch_Stand-1)
	.byte <(.__Grinch_Stand-1)
	.byte <(.__Grinch_Stand-1)
	.byte <(.__Grinch_WalkA-1)
	.byte <(.__Grinch_WalkB-1)
	.byte <(.__Grinch_WalkA-1)
	.byte <(.__Grinch_WalkC-1)
.
 ; 

.__Grinch_Stand
 ; __Grinch_Stand

.L0113 ;  player0:

	LDX #<playerL0113_0
	STX player0pointerlo
	LDA #((>playerL0113_0) & $0f) | (((>playerL0113_0) / 2) & $70)
	STA player0pointerhi
	LDA #30
	STA player0height
.
 ; 

.L0114 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.__Grinch_WalkA
 ; __Grinch_WalkA

.L0115 ;  player0:

	LDX #<playerL0115_0
	STX player0pointerlo
	LDA #((>playerL0115_0) & $0f) | (((>playerL0115_0) / 2) & $70)
	STA player0pointerhi
	LDA #30
	STA player0height
.L0116 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.__Grinch_WalkB
 ; __Grinch_WalkB

.L0117 ;  player0:

	LDX #<playerL0117_0
	STX player0pointerlo
	LDA #((>playerL0117_0) & $0f) | (((>playerL0117_0) / 2) & $70)
	STA player0pointerhi
	LDA #30
	STA player0height
.L0118 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.__Grinch_WalkC
 ; __Grinch_WalkC

.L0119 ;  player0:

	LDX #<playerL0119_0
	STX player0pointerlo
	LDA #((>playerL0119_0) & $0f) | (((>playerL0119_0) / 2) & $70)
	STA player0pointerhi
	LDA #30
	STA player0height
.L0120 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.
 ; 

.L0121 ;  bank 3

 if ECHO2
 echo "    ",[(start_bank2 - *)]d , "bytes of ROM space left in bank 2")
 endif
ECHO2 = 1
 ORG $2FF4-bscode_length
 RORG $3FF4-bscode_length
start_bank2 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha
 pha
 txa
 pha
 tsx
 if bankswitch != 64
   lda 4,x ; get high byte of return address
   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 ORG $2FFC
 RORG $3FFC
 .word start_bank2
 .word start_bank2
 ORG $3000
 RORG $5000
 repeat 129
 .byte 0
 repend
.L0122 ;  temp1 = temp1

	LDA temp1
	STA temp1
.
 ; 

.__Set_Level
 ; __Set_Level

.
 ; 

.L0123 ;  bkcolors:

	LDA #<BKCOLS
	STA DF0LOW
	LDA #(>BKCOLS) & $0F
	STA DF0HI
	LDA #<backgroundcolorL0123
	STA PARAMETER
	LDA #((>backgroundcolorL0123) & $0f) | (((>backgroundcolorL0123) / 2) & $70)
	STA PARAMETER
	LDA #0
	STA PARAMETER
	LDA #1
	STA PARAMETER
	LDA #1
	STA CALLFUNCTION
.
 ; 

.L0124 ;  on level goto __L0

	LDX level
	LDA .L0124jumptablehi,x
	PHA
	LDA .L0124jumptablelo,x
	PHA
	RTS
.L0124jumptablehi
	.byte >(.__L0-1)
.L0124jumptablelo
	.byte <(.__L0-1)
.
 ; 

.__L0
 ; __L0

.L0125 ;  room_index  =  5

	LDA #5
	STA room_index
.L0126 ;  goto __Set_Level_Return

 jmp .__Set_Level_Return

.
 ; 

.__Set_Level_Return
 ; __Set_Level_Return

.L0127 ;  gosub __Set_Room

 jsr .__Set_Room

.L0128 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.__Set_Room
 ; __Set_Room

.L0129 ;  temp1  =  level  *  16

	LDA level
	asl
	asl
	asl
	asl
	STA temp1
.L0130 ;  temp2  =  temp1  +   ( room_index  &  15 ) 

; complex statement detected
	LDA temp1
	PHA
	LDA room_index
	AND #15
	TSX
	INX
	TXS
	CLC
	ADC $00,x
	STA temp2
.L0131 ;  room  =  level_map[temp2]

	LDX temp2
	LDA level_map,x
	STA room
.
 ; 

.L0132 ;  on room goto __R0

	LDX room
	LDA .L0132jumptablehi,x
	PHA
	LDA .L0132jumptablelo,x
	PHA
	RTS
.L0132jumptablehi
	.byte >(.__R0-1)
.L0132jumptablelo
	.byte <(.__R0-1)
.
 ; 

.__R0
 ; __R0

.L0133 ;  temp6  =  0 :  gosub __Set_Room_Color

	LDA #0
	STA temp6
 jsr .__Set_Room_Color

.L0134 ;  stair_index  =  0

	LDA #0
	STA stair_index
.L0135 ;  playfield:

 ldy #22
	LDA #<PF_data1
	LDX #((>PF_data1) & $0f) | (((>PF_data1) / 2) & $70)
 sta temp7
 lda #>(ret_point4-1)
 pha
 lda #<(ret_point4-1)
 pha
 lda #>(pfsetup-1)
 pha
 lda #<(pfsetup-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #1
 jmp BS_jsr
ret_point4
.
 ; 

.L0136 ;  goto __Set_Room_Return

 jmp .__Set_Room_Return

.
 ; 

.__Set_Room_Return
 ; __Set_Room_Return

.L0137 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.__Set_Room_Color
 ; __Set_Room_Color

.L0138 ;  on temp6 goto __C0

	LDX temp6
	LDA .L0138jumptablehi,x
	PHA
	LDA .L0138jumptablelo,x
	PHA
	RTS
.L0138jumptablehi
	.byte >(.__C0-1)
.L0138jumptablelo
	.byte <(.__C0-1)
.
 ; 

.__C0
 ; __C0

.L0139 ;  pfcolors:

	LDA #<PFCOLS
	STA DF0LOW
	LDA #(>PFCOLS) & $0F
	STA DF0HI
	LDA #<playfieldcolorL0139
	STA PARAMETER
	LDA #((>playfieldcolorL0139) & $0f) | (((>playfieldcolorL0139) / 2) & $70)
	STA PARAMETER
	LDA #0
	STA PARAMETER
	LDA #22
	STA PARAMETER
	LDA #1
	STA CALLFUNCTION
.L0140 ;  goto __Set_Room_Color_Return

 jmp .__Set_Room_Color_Return

.
 ; 

.__Set_Room_Color_Return
 ; __Set_Room_Color_Return

.
 ; 

.L0141 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.L0142 ;  data level_map

	JMP .skipL0142
level_map
	.byte   $FF, $FF, $FF, $FF 

	.byte   $01, $00, $FF, $FF 

	.byte   $FF, $FF, $FF, $FF 

	.byte   $FF, $FF, $FF, $FF

.skipL0142
.
 ; 

.L0143 ;  bank 4

 if ECHO3
 echo "    ",[(start_bank3 - *)]d , "bytes of ROM space left in bank 3")
 endif
ECHO3 = 1
 ORG $3FF4-bscode_length
 RORG $5FF4-bscode_length
start_bank3 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha
 pha
 txa
 pha
 tsx
 if bankswitch != 64
   lda 4,x ; get high byte of return address
   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 ORG $3FFC
 RORG $5FFC
 .word start_bank3
 .word start_bank3
 ORG $4000
 RORG $7000
 repeat 129
 .byte 0
 repend
.L0144 ;  temp1 = temp1

	LDA temp1
	STA temp1
.
 ; 

.
 ; 

.L0145 ;  bank 5

 if ECHO4
 echo "    ",[(start_bank4 - *)]d , "bytes of ROM space left in bank 4")
 endif
ECHO4 = 1
 ORG $4FF4-bscode_length
 RORG $7FF4-bscode_length
start_bank4 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha
 pha
 txa
 pha
 tsx
 if bankswitch != 64
   lda 4,x ; get high byte of return address
   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 ORG $4FFC
 RORG $7FFC
 .word start_bank4
 .word start_bank4
 ORG $5000
 RORG $9000
 repeat 129
 .byte 0
 repend
.L0146 ;  temp1 = temp1

	LDA temp1
	STA temp1
.
 ; 

.
 ; 

.L0147 ;  bank 6

 if ECHO5
 echo "    ",[(start_bank5 - *)]d , "bytes of ROM space left in bank 5")
 endif
ECHO5 = 1
 ORG $5FF4-bscode_length
 RORG $9FF4-bscode_length
start_bank5 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha
 pha
 txa
 pha
 tsx
 if bankswitch != 64
   lda 4,x ; get high byte of return address
   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 ORG $5FFC
 RORG $9FFC
 .word start_bank5
 .word start_bank5
 ORG $6000
 RORG $B000
 repeat 129
 .byte 0
 repend
.L0148 ;  temp1 = temp1
	LDA temp1
	STA temp1
 if ECHO6
 echo "    ",[(start_bank6 - *)]d , "bytes of ROM space left in bank 6")
 endif
ECHO6 = 1
 ORG $6FF4-bscode_length
 RORG $BFF4-bscode_length
start_bank6 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha
 pha
 txa
 pha
 tsx
 if bankswitch != 64
   lda 4,x ; get high byte of return address
   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 ORG $6FFC
 RORG $BFFC
 .word start_bank6
 .word start_bank6
 ORG $7000
 RORG $D000
 repeat 129
 .byte 0
 repend
;----------------------------------------
; Display Data
;----------------------------------------
; The Display Data bank is copied into RAM when DPC+ initializes the cartridge.
; This allows us to manipulate the data during run-time, but have a known
; starting state when the Atari is first turned on.
;
; Unlike normal Atari VCS/2600 sprite definitions, the sprite data in the
; Display Data bank is stored right-side-up.
;
;----------------------------------------

Zeros32:
SOUND_OFF = (* & $1fff)/32
DisplayDataDigitBlank:
        .byte 0;--
        .byte 0;--
        .byte 0;--
        .byte 0;--
        .byte 0;--
        .byte 0;--
        .byte 0;--
        .byte 0;--
        
;	align 32
;Zeros32:
;SOUND_OFF = (* & $1fff)/32
;	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0    
	
SINE_WAVE = (* & $1fff)/32
	.byte 3,3,3,4,4,5,5,5
	.byte 5,5,5,5,4,4,3,3
	.byte 3,2,2,1,1,0,0,0
	.byte 0,0,0,0,1,1,2,2 

	align 32
TRIANGLE_WAVE = (* & $1fff)/32
	.byte 0,0,1,1,1,2,2,2
	.byte 3,3,3,4,4,4,5,5
	.byte 5,5,4,4,4,3,3,3
	.byte 2,2,2,1,1,1,0,0
	
 	align 32
SAWTOOTH_WAVE = (* & $1fff)/32
	.byte 0,0,0,0,1,1,1,1
	.byte 1,1,2,2,2,2,2,2
	.byte 3,3,3,3,3,3,4,4
	.byte 4,4,4,4,5,5,5,5
	
	align 32
SQUARE_WAVE_VOL5 = (* & $1fff)/32
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 5,5,5,5,5,5,5,5
	.byte 5,5,5,5,5,5,5,5

	align 32
SQUARE_WAVE_VOL4 = (* & $1fff)/32
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 4,4,4,4,4,4,4,4
	.byte 4,4,4,4,4,4,4,4

	align 32
SQUARE_WAVE_VOL3 = (* & $1fff)/32
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 3,3,3,3,3,3,3,3
	.byte 3,3,3,3,3,3,3,3
	
	align 32
NOISE_WAVE = (* & $1fff)/32
	.byte  7, 1, 9,10, 2, 8, 8,14
	.byte  3,13, 8, 5,12, 2, 3, 7
	.byte  7, 1, 8, 4,15, 1,13, 5
	.byte  8, 5,11, 6, 8, 7, 9, 2

; low and high byte of address table (for ROMdata array in C)
        .byte <fetcher_address_table
        .byte ((>fetcher_address_table) & $0f) | (((>fetcher_address_table) / 2) & $70)
 .byte 0
 .byte 0
FETCHER_BEGIN
 .byte 16
 .byte 16
 .byte 16
 .byte 16 ; to zero-fill on boot
;bB.asm
; bB.asm file is split here
playercolorL0111_0
	.byte  $0E
	.byte  $42
	.byte  $42
	.byte  $42
	.byte  $42
	.byte  $0E
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $42
	.byte  $42
	.byte  $42
	.byte  $42
	.byte  $42
	.byte  $42
	.byte  $0E
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $C8
	.byte  $0E
	.byte  $42
playerL0113_0
	.byte  %00000000
	.byte  %00001100
	.byte  %00001100
	.byte  %00011110
	.byte  %00011110
	.byte  %00111101
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
	.byte  %00011000
	.byte  %00111000
	.byte  %01111100
	.byte  %11111100
	.byte  %11111100
	.byte  %10111110
	.byte  %10111110
	.byte  %10111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
	.byte  %00111100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %01111110
playerL0115_0
	.byte  %01000000
	.byte  %00110000
	.byte  %00110000
	.byte  %00111000
	.byte  %00111000
	.byte  %01111000
	.byte  %01111000
	.byte  %11111100
	.byte  %11111100
	.byte  %11111100
	.byte  %11111100
	.byte  %01111000
	.byte  %00110000
	.byte  %00110000
	.byte  %01111000
	.byte  %01111000
	.byte  %01111000
	.byte  %01111100
	.byte  %01111100
	.byte  %01111100
	.byte  %01111100
	.byte  %01111100
	.byte  %00111000
	.byte  %00111000
	.byte  %00011000
	.byte  %00011000
	.byte  %00110000
	.byte  %00110000
	.byte  %01111000
	.byte  %01111100
playerL0117_0
	.byte  %00001000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011100
	.byte  %00011100
	.byte  %00111100
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
	.byte  %00011000
	.byte  %00111000
	.byte  %01111100
	.byte  %01111100
	.byte  %01111100
	.byte  %11111110
	.byte  %11111110
	.byte  %10111110
	.byte  %10111111
	.byte  %10111111
	.byte  %00111100
	.byte  %00011100
	.byte  %00001100
	.byte  %00101100
	.byte  %01101100
	.byte  %01001100
	.byte  %11000110
	.byte  %01100111
playerL0119_0
	.byte  %00001000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011100
	.byte  %00011100
	.byte  %00111100
	.byte  %00111100
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %01111110
	.byte  %00111100
	.byte  %00011000
	.byte  %00111000
	.byte  %00111100
	.byte  %00011100
	.byte  %00011100
	.byte  %10101110
	.byte  %10110110
	.byte  %10111010
	.byte  %10111101
	.byte  %10111101
	.byte  %00111100
	.byte  %00111100
	.byte  %01111000
	.byte  %01110000
	.byte  %01100100
	.byte  %01000100
	.byte  %11000110
	.byte  %01100111
backgroundcolorL0123
	.byte  $00
PF_data1
	.byte %11111111
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %11111111
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100011
	.byte %11100011
	.byte %11100011
	.byte %11100011
	.byte %11100011
	.byte %11111111
	.byte %11111111
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %01110000
	.byte %01110000
	.byte %01110000
	.byte %01110000
	.byte %01110000
	.byte %11111111
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %01101101
	.byte %00000001
	.byte %01101101
	.byte %00000001
	.byte %00000001
	.byte %11111111
	.byte %11111111
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %11111000
	.byte %00011100
	.byte %00001110
	.byte %00000111
	.byte %00000011
	.byte %00000111
	.byte %00001110
	.byte %00011100
	.byte %00111000
	.byte %01110000
	.byte %11111111
	.byte %11111111
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100000
	.byte %11100001
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %11111111
playfieldcolorL0139
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $74
	.byte  $72
 if ECHOFIRST
       echo "    ",[(DPC_graphics_end - *)]d , "bytes of ROM space left in graphics bank")
 endif 
ECHOFIRST = 1
 
 
       ORG $7FF4-bscode_length
       RORG $DFF4-bscode_length
DPC_graphics_end

; every bank has this stuff at the same place
; this code can switch to/from any bank at any entry point
; and can preserve register values
; note: lines not starting with a space are not placed in all banks
;
; line below tells the compiler how long this is - do not remove
;size=32

begin_bscode
 ldx #$ff
 ifconst FASTFETCH ; using DPC+
 stx FASTFETCH
 endif 
 txs
 if bankswitch == 64
   lda #(((>(start-1)) & $0F) | $F0)
 else
   lda #>(start-1)
 endif
 pha
 lda #<(start-1)
 pha

BS_return
 pha
 txa
 pha
 tsx

 if bankswitch != 64
   lda 4,x ; get high byte of return address

   rol
   rol
   rol
   rol
   and #bs_mask ;1 3 or 7 for F8/F6/F4
   tax
   inx
 else
   lda 4,x ; get high byte of return address
   tay
   ora #$10 ; change our bank nibble into a valid rom mirror
   sta 4,x
   tya
   lsr 
   lsr 
   lsr 
   lsr 
   tax
   inx
 endif

BS_jsr
 lda bankswitch_hotspot-1,x
 pla
 tax
 pla
 rts
 if ((* & $1FFF) > ((bankswitch_hotspot & $1FFF) - 1))
   echo "WARNING: size parameter in banksw.asm too small - the program probably will not work."
   echo "Change to",[(*-begin_bscode+1)&$FF]d,"and try again."
 endif
 org $8000
 rorg $1000
; 1K Frequency Table.
; Fred Quimby, Darrell Spice Jr, Chris Walton 2010
;
; The 1K Frequency Table can contain up to 256 frequency values
;
; Table entries are defined as 2^32*freq/20000
;
; If User ARM code is being used, then the last 512 bytes of the frequency
; table will no longer be available, reducing the number of frequencies you can
; use to 128.

; piano key frequencies (s = sharp)

.freq_table_start

			DC.L 0
A0  = (* & $3ff)/4
			DC.L 5905580
			
A0s = (* & $3ff)/4
			DC.L 6256744

B0  = (* & $3ff)/4	
			DC.L 6628789
			
C1  = (* & $3ff)/4
			DC.L 7022958
			
C1s = (* & $3ff)/4			
			DC.L 7440565
			
D1  = (* & $3ff)/4			
			DC.L 7883004
			
D1s = (* & $3ff)/4		
			DC.L 8351751
			
E1  = (* & $3ff)/4			
			DC.L 8848372
			
F1  = (* & $3ff)/4			
			DC.L 9374524
			
F1s = (* & $3ff)/4			
			DC.L 9931962
			
G1  = (* & $3ff)/4			
			DC.L 10522547
			
G1s = (* & $3ff)/4			
			DC.L 11148251
			
A1  = (* & $3ff)/4			
			DC.L 11811160
			
A1s = (* & $3ff)/4			
			DC.L 12513488
			
B1  = (* & $3ff)/4			
			DC.L 13257579
			
C2  = (* & $3ff)/4			
			DC.L 14045916
			
C2s = (* & $3ff)/4			
			DC.L 14881129
			
D2  = (* & $3ff)/4			
			DC.L 15766007
			
D2s = (* & $3ff)/4			
			DC.L 16703503
			
E2  = (* & $3ff)/4			
			DC.L 17696745
			
F2  = (* & $3ff)/4			
			DC.L 18749048
			
F2s = (* & $3ff)/4			
			DC.L 19863924
			
G2  = (* & $3ff)/4			
			DC.L 21045095
			
G2s = (* & $3ff)/4			
			DC.L 22296501
			
A2  = (* & $3ff)/4			
			DC.L 23622320
			
A2s = (* & $3ff)/4			
			DC.L 25026976
			
B2  = (* & $3ff)/4			
			DC.L 26515158
			
C3  = (* & $3ff)/4			
			DC.L 28091831
			
C3s = (* & $3ff)/4			
			DC.L 29762258
			
D3  = (* & $3ff)/4			
			DC.L 31532014
			
D3s = (* & $3ff)/4			
			DC.L 33407005
			
E3  = (* & $3ff)/4			
			DC.L 35393489
			
F3  = (* & $3ff)/4			
			DC.L 37498096
			
F3s = (* & $3ff)/4			
			DC.L 39727849
			
G3  = (* & $3ff)/4			
			DC.L 42090189
			
G3s = (* & $3ff)/4			
			DC.L 44593002
			
A3  = (* & $3ff)/4			
			DC.L 47244640
			
A3s = (* & $3ff)/4			
			DC.L 50053953
			
B3  = (* & $3ff)/4			
			DC.L 53030316
			
C4  = (* & $3ff)/4			
			DC.L 56183662
			
C4s = (* & $3ff)/4			
			DC.L 59524517
			
D4  = (* & $3ff)/4			
			DC.L 63064029
			
D4s = (* & $3ff)/4			
			DC.L 66814011
			
E4  = (* & $3ff)/4			
			DC.L 70786979
			
F4  = (* & $3ff)/4			
			DC.L 74996192
			
F4s = (* & $3ff)/4			
			DC.L 79455697
			
G4  = (* & $3ff)/4			
			DC.L 84180379
			
G4s = (* & $3ff)/4			
			DC.L 89186005
			
A4  = (* & $3ff)/4			
			DC.L 94489281
			
A4s = (* & $3ff)/4			
			DC.L 100107906
			
B4  = (* & $3ff)/4			
			DC.L 106060631
			
C5  = (* & $3ff)/4			
			DC.L 112367325
			
C5s = (* & $3ff)/4			
			DC.L 119049034
			
D5  = (* & $3ff)/4			
			DC.L 126128057
			
D5s = (* & $3ff)/4			
			DC.L 133628022
			
E5  = (* & $3ff)/4			
			DC.L 141573958
			
F5  = (* & $3ff)/4			
			DC.L 149992383
			
F5s = (* & $3ff)/4			
			DC.L 158911395
			
G5  = (* & $3ff)/4			
			DC.L 168360758
			
G5s = (* & $3ff)/4			
			DC.L 178372009
			
A5  = (* & $3ff)/4			
			DC.L 188978561
			
A5s = (* & $3ff)/4			
			DC.L 200215811
			
B5  = (* & $3ff)/4			
			DC.L 212121263
			
C6  = (* & $3ff)/4			
			DC.L 224734649
			
C6s = (* & $3ff)/4			
			DC.L 238098067
			
D6  = (* & $3ff)/4			
			DC.L 252256115
			
D6s = (* & $3ff)/4			
			DC.L 267256044
			
E6  = (* & $3ff)/4			
			DC.L 283147915
			
F6  = (* & $3ff)/4			
			DC.L 299984767
			
F6s = (* & $3ff)/4			
			DC.L 317822789
			
G6  = (* & $3ff)/4			
			DC.L 336721516
			
G6s = (* & $3ff)/4			
			DC.L 356744019
			
A6  = (* & $3ff)/4			
			DC.L 377957122
			
A6s = (* & $3ff)/4			
			DC.L 400431622
			
B6  = (* & $3ff)/4			
			DC.L 424242525
			
C7  = (* & $3ff)/4			
			DC.L 449469299
			
C7s = (* & $3ff)/4			
			DC.L 476196134
			
D7  = (* & $3ff)/4			
			DC.L 504512230
			
D7s = (* & $3ff)/4			
			DC.L 534512088
			
E7  = (* & $3ff)/4			
			DC.L 566295831
			
F7  = (* & $3ff)/4			
			DC.L 599969533
			
F7s = (* & $3ff)/4			
			DC.L 635645578
			
G7  = (* & $3ff)/4			
			DC.L 673443031
			
G7s = (* & $3ff)/4			
			DC.L 713488038
			
A7  = (* & $3ff)/4			
			DC.L 755914244
			
A7s = (* & $3ff)/4			
			DC.L 800863244
			
B7  = (* & $3ff)/4			
			DC.L 848485051
			
C8  = (* & $3ff)/4			
			DC.L 898938597

;values for 89-255 may go here 

	if (* <= $1400)
	  ds ($1400-*) ; pad out remaining space in frequency table
	else
	  echo "FATAL ERROR - Frequency table exceeds 1K"
	  err
	endif
